// ==UserScript==
// @name GooglePageRank
// @description GooglePageRank擾ĕ\
// @include http://*
// @type SleipnirScript 
// ==/UserScript==
if(_document.title.indexOf("[R")!=0){
	while(_window.busy){
		sleipnir.Sleep(10);
	}
	if(_document.title.indexOf("[R")!=0){
		var t=_document.title;
		var pr=getPageRank(_document.location.href);
		if(_document.title.indexOf("[R")!=0){
			_document.title="[R"+pr+"]"+t;
		}
	}
}

function getPageRank(url){
	if(!url.match(/http:\/\//)){
		return -1;
	}
	var http = new ActiveXObject("Microsoft.XMLHTTP");
	url=url.replace(/\?.*$/,"");
	var ch='6' + _compute_ch_new("info:" + url);
	//var query= "http://toolbarqueries.google.com/search?client=navclient-auto&ch="+ch+"&ie=UTF-8&oe=UTF-8&features=Rank&q=info:"+encodeURI(url);
	var query= "http://toolbarqueries.google.com/tbr?client=navclient-auto&features=Rank&ch="+ch+"&q=info:"+encodeURI(url);
	http.open("GET",query,false);
	http.setRequestHeader('User-Agent','Mozilla/4.0 (compatible; GoogleToolbar 2.0.111-big; Windows XP 5.1)');
	http.send(null);
	if(http.responseText.match(/Rank_\d+:\d+:(\d+)/i)){
		return(RegExp.$1);
	}
}

function _compute_ch_new(url){
	var ch = _compute_ch(url);
	ch = ((ch % 0x0d) & 7) | ((ch / 7) << 2);
	var ary=new Array,tmp=ch;
	for(i=0;i<20;i++){
		tmp=_ws(ch,i*9);
		ary.push(tmp&0xFF);
		ary.push((tmp>>8)&0xFF);
		ary.push((tmp>>16)&0xFF);
		ary.push((tmp>>24)&0xFF);
	}
	return _compute_ch(url,ary);
}

function _compute_ch(aUrl,aArray){
	var init=0xe6359a60,
		a=0x9e3779b9,
		b=0x9e3779b9,
		c=0xe6359a60,
		k=0;
	var url=new Array,
		len=0;
	if(aArray){
		url=aArray;
	}else{
		for (var i=0;i<aUrl.length;i++){
			var code=aUrl.charCodeAt(i);
			if(code>255){
				url.push(code>>8);
				url.push(code&0xFF);
			}else{
				url.push(code);
			}
		}
	}
	len=url.length;
	
	while(len>=12){
		a=_wa(a, _us(url[k+0] | _us(url[k+1] << 8) | _us(url[k+2] << 16) | _us(url[k+3] << 24)));
		b=_wa(b, _us(url[k+4] | _us(url[k+5] << 8) | _us(url[k+6] << 16) | _us(url[k+7] << 24)));
		c=_wa(c, _us(url[k+8] | _us(url[k+9] << 8) | _us(url[k+10] << 16) | _us(url[k+11] << 24)));
		var tmp=_mix(a, b, c);
		a=tmp[0];b=tmp[1];c=tmp[2];
		k += 12;
		len -= 12;
	}
	c=_wa(c,url.length);
	if(len > 10) c=_wa(c, url[k+10] << 24);
	if(len > 9) c=_wa(c, url[k+9] << 16);
	if(len > 8) c=_wa(c, url[k+8] << 8);
	if(len > 7) b=_wa(b, url[k+7] << 24);
	if(len > 6) b=_wa(b, url[k+6] << 16);
	if(len > 5) b=_wa(b, url[k+5] << 8);
	if(len > 4) b=_wa(b, url[k+4]);
	if(len > 3) a=_wa(a, url[k+3] << 24);
	if(len > 2) a=_wa(a, url[k+2] << 16);
	if(len > 1) a=_wa(a, url[k+1] << 8);
	if(len > 0) a=_wa(a, url[k]);
	
	var tmp = _mix(a,b,c)[2];
	return(tmp);
}
function _mix(a,b,c){
	a=_ws(a,b); a=_ws(a,c); a ^= c >>> 13;						a=_us(a);
	b=_ws(b,c); b=_ws(b,a); b ^= _us((a << 8) % 4294967296);	b=_us(b);
	c=_ws(c,a); c=_ws(c,b); c ^= b >>>13;						c=_us(c);
	a=_ws(a,b); a=_ws(a,c); a ^= c >>> 12;                    a=_us(a);
	b=_ws(b,c); b=_ws(b,a); b ^= _us((a << 16) % 4294967296); b=_us(b);
	c=_ws(c,a); c=_ws(c,b); c ^= b >>> 5;                     c=_us(c);
	a=_ws(a,b); a=_ws(a,c); a ^= c >>> 3;						a=_us(a);
	b=_ws(b,c); b=_ws(b,a); b ^= _us((a << 10) % 4294967296); b=_us(b);
	c=_ws(c,a); c=_ws(c,b); c ^= b >>> 15;                    c=_us(c);

	return([a,b,c]);
}
function _wa(a,b){
	return(_us((a+b)%4294967296));
}
function _ws(a,b){
	return(_us((a-b)%4294967296));
}
function _us(v){
	return(v<0?v+4294967296:v);
}

